;####################################################
;##  GTSDll v1.2.7.0 Updater                       ##
;####################################################
;##  (Part of GTSdll)                              ##
;##                                                ##
;##  by GTS - #gtsdll @ irc.rizon.net              ##
;##                                                ##
;##  Homepage:                                     ##
;##  http://www.gts-stuff.com/                     ##
;##                                                ##
;####################################################

on *:sockopen:GTSDLL.updatechecker: {
  echo -ag * Checking for a GTSdll update ...
  if ($sockerr) { echo -ag * Can't connect $sock($sockname).wsmsg | return }
  var %a = sockwrite -n GTSDLL.updatechecker
  %a GET http://update.gts-stuff.com/?ID=1&Action=version HTTP/1.0
  %a Host: update.gts-stuff.com
  %a From: gtsdllupdater@gts-stuff.com
  %a User-Agent: GTSUPD/1.0
  %a Accept: */*
  %a Connection: close
  %a
}
on *:sockread:GTSDLL.updatechecker: {
  if ($sockerr) { echo -ag * Check for updates failed. $sock($sockname).wsmsg | return }
  :readsock
  sockread -f %tmp
  ; echo -ag * GTSDLL.updatechecker * %tmp
  if (VERSION:* iswm %tmp) {
    set %GTSDLL-Version $gettok(%tmp,2,32)
    var %GTSDLL-OldVer $gtsdllver(numver) 
    if (%GTSDLL-OldVer < %GTSDLL-Version) { 
      echo -ag * Newer GTSdll release found ... 
      if ($hget(GTSDll_settings,au_ask_user) == $false) {
        echo -ag * Initiating Auto-Update ...
        GTSdll_start_autoupdate
      }
      else {
        ;echo -ag * Asking user how to proceed...
        GTSdll_start_autoupdate confirm
      }
    }
    else { 
      echo -ag * No update found.
      sockclose GTSDLL.updatechecker
      .unload -rs " $+ $scriptdir $+ gtsupd.mrc"
    }
  }
  if (!$sockbr) { return }
  goto readsock
}


;### dialog handling ###

dialog -l ask_user_for_update  {
  title "GTSdll Updater"
  size -1 -1 135 43
  option dbu
  text "A newer version of GTSdll was found.", 1, 2 0 93 8
  text "Should i download and install it automatically for you?", 2, 2 9 129 8
  button "Yes, Proceed.", 3, 2 30 37 12, ok
  button "No, Cancel", 4, 41 30 37 12, cancel
  button "Download manually", 6, 80 30 53 12
  check "Don't check for Updates anymore.", 5, 2 20 110 10
}
dialog -l gtsdll_updater {
  title "GTSdll Updater - Status"
  size -1 -1 101 18
  option dbu
  text "Status:", 1, 3 10 90 8
  button "Button", 2, 124 2 10 8, hide ok cancel
  text "Please wait ...", 3, 3 2 41 8
}

on 1:DIALOG:ask_user_for_update:sclick:3: {
  if ($did(ask_user_for_update,5).state) {
    .hadd GTSDll_settings au_checkonstart $false
  }
  else {
    .hadd GTSDll_settings au_checkonstart $true
  }
  GTSdll_start_autoupdate
}
on 1:DIALOG:ask_user_for_update:sclick:4: {
  if ($did(ask_user_for_update,5).state) {
    .hadd GTSDll_settings au_checkonstart $false
  }
  else {
    .hadd GTSDll_settings au_checkonstart $true
  }
  echo -ag * Update process canceled by user.
}

on 1:DIALOG:gtsdll_settings:sclick:55:{
  dialog -c gtsdll_settings
  .timer 1 0 downloadGTSDLL
}
on 1:DIALOG:ask_user_for_update:sclick:6: {
  if ($did(ask_user_for_update,5).state) {
    .hadd GTSDll_settings au_checkonstart $false
  }
  else {
    .hadd GTSDll_settings au_checkonstart $true
  }
  echo -ag * Update process canceled by user.
  run http://www.gts-stuff.com/
  dialog -x ask_user_for_update
}

;### dialog handling end ###


;#######################
;### starting update ###
;#######################

alias -l GTSdll_start_autoupdate {
  if ($1 == confirm) {
    dialog -m ask_user_for_update ask_user_for_update
    return
  }
  downloadGTSDLL
}

alias -l downloadGTSDLL {
  dialog -m gtsdll_updater gtsdll_updater
  sockopen GTSDLL.getlocation $hget(GTSDll_settings,Site) $hget(GTSDll_settings,Port)
  mkdir " $+ $scriptdir $+ temp\"
}

;### request location of file ###
on *:SOCKOPEN:GTSDLL.getlocation: {
  if ($sockerr) { did -o gtsdll_updater 1 1 Can't connect $sock($sockname).wsmsg | return }
  did -o gtsdll_updater 1 1 Requesting location ...
  var %a = sockwrite -n GTSDLL.getlocation
  %a GET http://update.gts-stuff.com/?ID=1&Action=download HTTP/1.0
  %a Host: update.gts-stuff.com
  %a From: gtsdllupdater@gts-stuff.com
  %a User-Agent: GTSUPD/1.0
  %a Accept: */*
  %a Connection: close
  %a
}

;### get location of file & filename ###
on *:sockread:GTSDLL.getlocation: {
  if ($sockerr) { echo -ag * Disconnected. $sock($sockname).wsmsg | return }
  :readsock
  sockread -f %tmp
  ;echo -ag * GTSDLL.getlocation * %tmp
  if (location:* iswm %tmp) {
    set %GTSDLL-location $gettok(%tmp,2,32)
    set %GTSDLL-filename $gettok(%GTSDLL-location,-1,47)
    ; If file already exist, delete it. The updater would append it otherwise...
    .remove " $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ "
    sockclose GTSDLL.getlocation
    ; just to make sure ...
    sockclose GTSDLL.getfile
    sockopen GTSDLL.getfile $hget(GTSDll_settings,Site) $hget(GTSDll_settings,Port)
  }
  if (!$sockbr) { return }
  goto readsock
}

;### request file ###
on *:SOCKOPEN:GTSDLL.getfile: {
  if ($sockerr) { did -o gtsdll_updater 1 1 Can't connect $sock($sockname).wsmsg | return }
  did -o gtsdll_updater 1 1 Requesting file ...
  var %a = sockwrite -n GTSDLL.getfile
  %a GET %GTSDLL-location HTTP/1.0
  %a Host: update.gts-stuff.com
  %a From: gtsdllupdater@gts-stuff.com
  %a User-Agent: GTSUPD/1.0
  %a Accept: */*
  %a Connection: close
  %a
  set %GTSDLL-downloadheader 0
}

;### download file ###
on *:SOCKREAD:GTSDLL.getfile: {
  if ($sockerr) { 
    did -o gtsdll_updater 1 1 Disconnected. $sock($sockname).wsmsg 
    .remove " $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ "
    return 
  }
  if (%GTSDLL-downloadheader == 0) {
    sockread %download.temp
    if ($gettok(%download.temp,1,32) == Content-Length:) { set %GTSDLL-size $gettok(%download.temp,2,32) }
    if ($len(%download.temp) < 4) {
      if (%GTSDLL-size == $null) { set %GTSDLL-size Unknown }
      set %GTSDLL-downloadheader 1
    }
    halt
  }
  did -a gtsdll_updater 1 Downloaded $int($calc($sock(GTSDLL.getfile).rcvd / %GTSDLL-size * 100)) $+ %
  :start
  sockread &tempfile
  if ($sockbr == 0) { return }
  bwrite " $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ " -1 &tempfile
  goto start
}

;### move on ... ###
on *:SOCKCLOSE:GTSDLL.getfile: {
  if ($exists(" $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ ")) {
    sockopen GTSDLL.getmd5 $hget(GTSDll_settings,Site) $hget(GTSDll_settings,Port)
  }
  else {
    did -a gtsdll_updater 1 Download failed...
    echo -ag * Download failed, please try again later.
  }
}

;### request MD5 checksum ###
on *:SOCKOPEN:GTSDLL.getmd5: {
  if ($sockerr) {
    did -o gtsdll_updater 1 1 Can't connect $sock($sockname).wsmsg 
    .remove " $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ "
    return 
  }
  did -o gtsdll_updater 1 1 Requesting MD5 checksum ...
  var %a = sockwrite -n GTSDLL.getmd5
  %a GET http://update.gts-stuff.com/?ID=1&Action=MD5 HTTP/1.0
  %a Host: update.gts-stuff.com
  %a From: gtsdllupdater@gts-stuff.com
  %a User-Agent: GTSUPD/1.0
  %a Accept: */*
  %a Connection: close
  %a
}

;### get md5 ###
on *:SOCKREAD:GTSDLL.getmd5: {
  did -o gtsdll_updater 1 1 Getting MD5 String
  if ($sockerr) { did -o gtsdll_updater 1 1 Disconnected - Update Canceled | return }
  :readsock
  sockread -f %tmp
  ;echo -ag * GTSDLL.getmd5 * %tmp
  if (MD5:* iswm %tmp) {
    set %GTSDLL-MD5 $gettok(%tmp,2,32)
  }
  if (!$sockbr) { return }
  goto readsock
}

;### last socket event ###
on *:SOCKCLOSE:GTSDLL.getmd5: { 
  if (%GTSDLL-MD5) {
    did -a gtsdll_updater 1 Calculating checkum of file... 
    finishUpdate
  } 
  else {
    .remove " $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ "
    did -a gtsdll_updater 1 Error: MD5 not found.
    echo -ag * Error: MD5 was not found, unable to check file validity. Please try again later.
  }
}

;### finish update ... ###
alias -l finishUpdate {
  ;echo -ag * %GTSDLL-MD5
  did -a gtsdll_updater 1 Checking file ...
  if ($md5(" $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ ",2) != %GTSDLL-MD5) {
    did -a gtsdll_updater 1 Download Error: MD5 doesnt match!
    echo -ag * Error: Checksums do not match. Please try again later.
    .remove " $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ "
    .rmdir " $+ $scriptdir $+ temp\"
    return
  }
  else {
    did -a gtsdll_updater 1 Finishing update ...
    if ($exists(" $+ $scriptdir $+ %GTSDLL-filename $+ ")) .remove " $+ $scriptdir $+ %GTSDLL-filename $+ "
    .rename " $+ $scriptdir $+ temp\ $+ %GTSDLL-filename $+ " " $+ $scriptdir $+ %GTSDLL-filename $+ "
    dll " $+ $scriptdir $+ gtsmirc.dll" UnZip $scriptdir $+ %GTSDLL-filename $+ $chr(1) $+ $scriptdir
    .remove " $+ $scriptdir $+ %GTSDLL-filename $+ "
    ; check if there is an installer ...
    if ($exists(" $+ $scriptdir $+ gtsinst.mrc")) {
      .load -rs " $+ $scriptdir $+ gtsinst.mrc"
      ; This is the alias that will be called, it should be inside the gtsinst.mrc then
      GTSDLL_gtsinst
      ; after that the file will be unloaded & removed
      .unload -rs " $+ $scriptdir $+ gtsinst.mrc"
      .remove " $+ $scriptdir $+ gtsinst.mrc"
    }
    dialog -c gtsdll_updater
  }
  unset %GTSDLL-Version %GTSDLL-location %GTSDLL-filename %GTSDLL-download.header %GTSDLL-size %GTSDLL-MD5 %GTSDLL-Version %tmp
  ; unload 
  .echo -ag * Update completed
  .timerunloadupd 1 1 .unload -rs " $+ $scriptdir $+ gtsupd.mrc"
  .rmdir " $+ $scriptdir $+ temp\"
}
